
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>

#include "array.c"

int main (void)

{
struct Window *win;
struct Message *msg;
struct RastPort temprp;
struct ColorMap *cm;
WORD pen[256];
long i;
ULONG r,g,b;
UBYTE *p;

if (win = OpenWindowTags (NULL,
		WA_Title,"PixelArray",
		WA_InnerWidth,BMWIDTH + 20,
		WA_InnerHeight,BMHEIGHT + 20,
		WA_Flags,WFLG_CLOSEGADGET|WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_ACTIVATE,
		WA_IDCMP,IDCMP_CLOSEWINDOW|IDCMP_MOUSEBUTTONS|IDCMP_VANILLAKEY,
		TAG_END))
	{

	cm = win->WScreen->ViewPort.ColorMap;
	p = palette;
	for (i = 0; i < 256; i++)
		{
		r = *p++ << 24;
		g = *p++ << 24;
		b = *p++ << 24;
		pen[i] = ObtainBestPen (cm,r,g,b,OBP_FailIfBad,FALSE,OBP_Precision,PRECISION_GUI,TAG_END);
		}

	p = array;
	for (i = (((BMWIDTH + 15) >> 4) << 4) * BMHEIGHT; i; i --)
		*p++ = pen[*p];

	temprp = *win->RPort;
	temprp.Layer = NULL;
	if (temprp.BitMap = AllocBitMap (BMWIDTH,1,8,0,NULL))
		{
		WritePixelArray8 (win->RPort,win->BorderLeft + 10,win->BorderTop + 10,
			win->BorderLeft + BMWIDTH + 9,win->BorderTop + BMHEIGHT + 9,array,&temprp);
		FreeBitMap (temprp.BitMap);
		}

	WaitPort (win->UserPort);

	while (msg = GetMsg (win->UserPort))
		ReplyMsg (msg);

	for (i = 0; i < 256; i++)
		ReleasePen (cm,pen[i]);

	CloseWindow (win);
	}

return (0);
}

